/* Prefork utility header file
 * shadows@whitefang.com */

#ifndef PREFORK_SOURCE
extern void init_daemon(char *logstr,int num,int max_children,int num_cycle,int perfork,
	    int (*func)(int),int sockd);
extern struct sockaddr_in peer;
#else
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <syslog.h>

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/time.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <signal.h>

#include <errno.h>

#define BUSY 1
#define READY 2

#define BUFFSIZE 512

struct child {
  unsigned char status;
  int sockd;
  pid_t child_pid;
  struct child *next;
};

static pid_t wait_dead(void);
static void wait_for_all_dead(void);
static int fork_child(int num);
static void child_main(int sockd);
static void child_died(int i);
static void kill_all(void);
static void add_child_to_list(int sockd,pid_t child_pid);
static unsigned char delete_child_from_list(pid_t child_pid);
static void init_lock(void);
static void remove_lock_file(void);
static void init_log(char *s);
static void close_log(void);
static void error_log(char *m, ...);
static int open_safe(char *path);
static sigset_t block_signals(void);
static void setup_signal_handlers(void);
static void shutdown_server(int i);
static int send_socket(int sockd, char *mesg, int size);
static int recv_socket(int sockd, char *buff, int size);
static void check_children(int i);
static void open_lock(void);
static int release_lock(void);
static int get_lock(void);
#endif
